/*
 * Lights.cpp
 *
 *  Created on: Feb 19, 2009
 *      Author: njoubert
 */

#include "Lights.h"


Light::Light() {
    RGB black(0,0,0);
    _illumination = black;
}

Light::Light(RGB illumination) {
    _illumination = illumination;
}
Light::~Light() { }

const RGB & Light::getColor() {
    return _illumination;
}

void Light::setColor(RGB c) {
    _illumination = c;
}

AmbientLight::AmbientLight() {
    //intentionally empty
}

AmbientLight::AmbientLight(RGB illumination) : Light(illumination) {
    //intentionally empty
}

void AmbientLight::getIncidenceVector(vec4 & position, vec4 & returnValue) {
    throw "AMBIENT LIGHTS DO NOT HAVE A SENSE OF DIRECTION OR POSITION";
}

PointLight::PointLight(RGB illumination) : Light(illumination){
    //intentionally empty
}

void PointLight::setPosition(vec4 pos) {
    _pos = pos;
}

void PointLight::getIncidenceVector(vec4 & position, vec4 & returnValue) {
    IMPLEMENT_ME(__LINE__, __FILE__);
}

DirectionalLight::DirectionalLight(RGB illumination) : Light(illumination){
    //intentionally empty
}

void DirectionalLight::setDirection(vec4 dir) {
    _dir = dir;
    _dir[VW] = 0.0;
}

void DirectionalLight::getIncidenceVector(vec4 & position, vec4 & returnValue) {
    IMPLEMENT_ME(__LINE__, __FILE__);
}
