#include "main.h"

using namespace std;

//****************************************************
// Global Variables
//****************************************************
Viewport * viewport;
World * world;
Film * film;
UCB::ImageSaver * imgSaver;
int frameCount = 0;



//-------------------------------------------------------------------------------
// Here you raycast a single ray, calculating the color of this ray.
RGB raycast(Ray & ray) {
    RGB retColor(0,0,0);

    RGB green(0,0.5,0);
    RGB blue(0,0.5,0);

    retColor += green;
    retColor += blue;






    //YOUR CODE HERE!!!


    //Please be sure to read the following classes in algebra3.h:
    // - Color
    // - Point (useful for storing sample information)
    // - Material
    // - Ray






    return retColor;
}

//-------------------------------------------------------------------------------
// Here you write your main render function. This calls the raycast method
// on each ray, which you generate using the Sampler and Ray classes.
void renderWithRaycasting() {
    Point point;    //This is the point on the viewport being sampled.
    Ray ray;        //This is the ray being traced from the eye through the point.
    RGB c;

    //As a suggestion:

    /*
    viewport->resetSampler();
    while(viewport->getSample(point)) {
        ray = viewport->createViewingRay(point);
        c = raycast(ray);
        film->expose(c, point);
    }
    */
}


//-------------------------------------------------------------------------------
/// You will be calling all of your drawing-related code from this function.
/// Nowhere else in your code should you use glBegin(...) and glEnd() except code
/// called from this method.
///
/// To force a redraw of the screen (eg. after mouse events or the like) simply call
/// glutPostRedisplay();
void display() {

	//Clear Buffers
    glClear(GL_COLOR_BUFFER_BIT);
	glMatrixMode(GL_MODELVIEW);					// indicate we are specifying camera transformations
	glLoadIdentity();							// make sure transformation is "zero'd"

	renderWithRaycasting();

	//Now that we've drawn on the buffer, swap the drawing buffer and the displaying buffer.
	glutSwapBuffers();
}


//-------------------------------------------------------------------------------
/// \brief	Called when the screen gets resized.
/// This gives you the opportunity to set up all the relevant transforms.
///
void reshape(int w, int h) {
	//Set up the viewport to ignore any size change.
	glViewport(0,0,viewport->getW(),viewport->getH());

	//Set up the PROJECTION transformationstack to be a simple orthographic [-1, +1] projection
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0,viewport->getW(),0,viewport->getH(), 1, -1);

	//Set the MODELVIEW transformation stack to the identity.
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}


//-------------------------------------------------------------------------------
/// Called to handle keyboard events.
void myKeyboardFunc(unsigned char key, int x, int y) {
	switch (key) {
        case 's':
            imgSaver->saveFrame();
            break;
		case 27:			// Escape key
			exit(0);
			break;
	}
}

void myMouseFunc(int button, int state, int x, int y) {
    //Your code here
}

void myMotionFunc(int x, int y) {
    //Your code here
}


//-------------------------------------------------------------------------------
/// Called to update the screen at 30 fps.
void frameTimer(int value){
    frameCount++;
    glutPostRedisplay();
    glutTimerFunc(1000/30, frameTimer, 1);
}

//-------------------------------------------------------------------------------
//// Here we set up the world and the viewport for rendering.
void createScene() {
    vec4 eye(0.0, 0.0, 0.0, 1.0);
    vec4 LL(-1.0, -1.0, -3.0, 1.0);
    vec4 UL(-1.0, 1.0, -3.0, 1.0);
    vec4 LR(1.0, -1.0, -3.0, 1.0);
    vec4 UR(1.0, 1.0, -3.0, 1.0);

    viewport = new Viewport(eye, LL, UL, LR, UR, IMAGE_WIDTH, IMAGE_HEIGHT);


    //YOUR CODE HERE





}

//-------------------------------------------------------------------------------
/// Initialize the environment
int main(int argc,char** argv) {

	//Initialize OpenGL
	glutInit(&argc,argv);
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGBA);

	//Initialize the screen capture class to save BMP captures
	//in the current directory, with the prefix "output"
	imgSaver = new UCB::ImageSaver("./", "raycaster");

    createScene();

	//Create OpenGL Window
	glutInitWindowSize(IMAGE_WIDTH,IMAGE_HEIGHT);
	glutInitWindowPosition(0,0);
	glutCreateWindow("CS184 Raycaster");

	//Register event handlers with OpenGL.
	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutKeyboardFunc(myKeyboardFunc);
	glutMouseFunc(myMouseFunc);
	glutMotionFunc(myMotionFunc);
	glutPassiveMotionFunc(myMotionFunc);
    frameTimer(0);

	//And Go!
	glutMainLoop();
}
